#include "khello.moc"
#include <qvbox.h>
#include <klineedit.h>
#include <kapp.h>
#include <kmenubar.h>
#include <klocale.h>
#include <kpopupmenu.h>
#include <khtml_part.h>
#include <kpushbutton.h>
#include <kmessagebox.h>

#include <kfiledialog.h>
#include <kdirselectdialog.h>
#include <kicondialog.h>

KHello::KHello ( const char * name ) : KMainWindow ( 0L, name )
{
    setCaption("ABCLinuxu.cz Browser");
    QPopupMenu * filemenu = new QPopupMenu;
    filemenu->insertItem( i18n( "&KFileDialog" ), this, SLOT( fileFileDialog() ) );
    filemenu->insertItem( i18n( "K&DirSelectDialog" ), this, SLOT( fileDirSel() ) );
    filemenu->insertItem( i18n( "K&IconDialog" ), this, SLOT( fileIconDialog() ) );

    filemenu->insertItem( i18n( "&Quit" ), kapp, SLOT( quit() ) );
    QString about = i18n("Ondrej Krško, 2003\n");

    QPopupMenu *helpmenu = helpMenu(about);
    KMenuBar * menu = menuBar();
    menu->insertItem( i18n( "&File" ), filemenu);
    menu->insertSeparator();
    menu->insertItem(i18n("&Help"), helpmenu);

    // vytvorim spravcu rozlozenia
    QVBox * vbox = new QVBox ( this );
    QHBox * hbox = new QHBox ( vbox );

    btnNav1 = new QPushButton (i18n("AbcLinuxu"), hbox );
    btnNav2 = new QPushButton (i18n("AbcPalírna"), hbox );
    btnNav3 = new QPushButton (i18n("Hardware"), hbox );


    location = new KLineEdit ( vbox );
    location->setText( "http://www.abclinuxu.cz/" );

    browser=new KHTMLPart( vbox );
    browser->openURL( location->text() );
    browser->setJavaEnabled(true);
    browser->setJScriptEnabled(true);

    connect( location , SIGNAL( returnPressed() ), this, SLOT( changeLocation() ) );
    connect( btnNav1, SIGNAL( clicked() ), this, SLOT( nav1() ) );
    connect( btnNav2, SIGNAL( clicked() ), this, SLOT( nav2() ) );
    connect( btnNav3, SIGNAL( clicked() ), this, SLOT( nav3() ) );
    connect( browser->browserExtension(),
        SIGNAL( openURLRequest( const KURL &, const KParts::URLArgs & ) ),
        this, SLOT( openURLRequest(const KURL &, const KParts::URLArgs & ) ) );

    setCentralWidget( vbox );
}

void KHello::changeLocation()
{
    browser->openURL( location->text() );
}

void KHello::nav1()
{
    browser->openURL( "http://www.abclinuxu.cz/" );
}

void KHello::nav2()
{
    browser->openURL( "http://www.abclinuxu.cz/palirna/index.html" );
}

void KHello::nav3()
{
    browser->openURL( "http://www.abclinuxu.cz/hardware/ViewRelation?relationId=1" );
}

void KHello::openURLRequest(const KURL &url, const KParts::URLArgs & )
{
    location->setText(url.url());
    changeLocation();
}

void KHello::fileFileDialog()
{
    KURL filename = KFileDialog::getOpenURL( QString::null, "*", this );
    KMessageBox::information( 0, filename.url(), i18n( "Information" ), "fileOpenInformationDialog" );
}

void KHello::fileDirSel()
{
    KURL dirname = KDirSelectDialog::selectDirectory(  );
    KMessageBox::information( 0, dirname.url(), i18n( "Information" ), "fileOpenInformationDialog" );
}

void KHello::fileIconDialog()
{
    QString iconname = KIconDialog::getIcon( );
    KMessageBox::information( 0, iconname, i18n( "Information" ), "fileOpenInformationDialog" );
}



